#include <X11/Intrinsic.h>
#include "stdefun.h"
#include "action.h"
#include "game.h"
#include "rotquad.h"
#include "debug.h"


void 
t3d_act_right _P4(
   (Widget,     w), 
   (XEvent *,   e), 
   (String *,   par), 
   (Cardinal *, npar))
{
   DHERE0;
   t3d_xymove( T3D_MV_PX );
} /* t3d_act_right */


void 
t3d_act_left _P4(
   (Widget,     w), 
   (XEvent *,   e), 
   (String *,   par), 
   (Cardinal *, npar))
{
   DHERE0;
   t3d_xymove( T3D_MV_NX );
} /* t3d_act_left */


void 
t3d_act_up _P4(
   (Widget,     w), 
   (XEvent *,   e), 
   (String *,   par), 
   (Cardinal *, npar))
{
   DHERE0;
   t3d_xymove( T3D_MV_PY );
} /* t3d_act_up */


void 
t3d_act_down _P4(
   (Widget,     w), 
   (XEvent *,   e), 
   (String *,   par), 
   (Cardinal *, npar))
{
   DHERE0;
   t3d_xymove( T3D_MV_NY );
} /* t3d_act_down */


void 
t3d_act_drop_down _P4(
   (Widget,     w), 
   (XEvent *,   e), 
   (String *,   par), 
   (Cardinal *, npar))
{
   DHERE0;
   t3d_drop_down();
} /* t3d_act_drop_down */


void 
t3d_act_rot_px _P4(
   (Widget,     w), 
   (XEvent *,   e), 
   (String *,   par), 
   (Cardinal *, npar))
{
   t3d_axe_rotate(T3D_ROTQUAD_PX);
} /* t3d_act_rot_px */


void 
t3d_act_rot_nx _P4(
   (Widget,     w), 
   (XEvent *,   e), 
   (String *,   par), 
   (Cardinal *, npar))
{
   t3d_axe_rotate(T3D_ROTQUAD_NX);
} /* t3d_act_rot_nx */


void 
t3d_act_rot_py _P4(
   (Widget,     w), 
   (XEvent *,   e), 
   (String *,   par), 
   (Cardinal *, npar))
{
   t3d_axe_rotate(T3D_ROTQUAD_PY);
} /* t3d_act_rot_py */


void 
t3d_act_rot_ny _P4(
   (Widget,     w), 
   (XEvent *,   e), 
   (String *,   par), 
   (Cardinal *, npar))
{
   t3d_axe_rotate(T3D_ROTQUAD_NY);
} /* t3d_act_rot_ny */


void 
t3d_act_rot_pz _P4(
   (Widget,     w), 
   (XEvent *,   e), 
   (String *,   par), 
   (Cardinal *, npar))
{
   t3d_axe_rotate(T3D_ROTQUAD_PZ);
} /* t3d_act_rot_pz */


void 
t3d_act_rot_nz _P4(
   (Widget,     w), 
   (XEvent *,   e), 
   (String *,   par), 
   (Cardinal *, npar))
{
   t3d_axe_rotate(T3D_ROTQUAD_NZ);
} /* t3d_act_rot_pz */
