#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include "stdefun.h"
#include "colorid.h"
#include "xcolorid.h"
#include "debug.h"


static  int cmid[T3D_CLR_N];

int 
t3d_colorid  _P1(
   (T3D_CLR,  ci)
)
{
   DASSERT(0 <= ci && ci < T3D_CLR_N);
   return( cmid[ ci ] );
} /* t3d_colorid */


void
t3d_colorid_init  _P1(
   (Widget,  w)
)
{
   static char *color_name[] = {
      "black", "white", "red", "green", "blue", "yellow", "cyan", "magenta",
   };

   char        Color_name[T3D_CLR_N][8]; /* 8 > strlen("magenta") */
   XtResource  colorid_res[T3D_CLR_N];
   int         i;

   
   DASSERT(XtNumber(color_name) == T3D_CLR_N);
   for (i = 0;  i < T3D_CLR_N;  i++) {
      colorid_res[i].resource_name = color_name[i];
      colorid_res[i].resource_class = strcpy(Color_name[i], colorid_res[i]);
         Color_name[i][0] = toupper(Color_name[i][0]); 
      colorid_res[i].resource_type = XtRInt;
      colorid_res[i].resource_size = sizeof(int);
      colorid_res[i].resource_offset = sizeof(int) * i;
      colorid_res[i].default_type = XtRImmediate;
      colorid_res[i].default_addr = (XtPointer)i;
   }

   XtGetApplicationResources(w, cmid, colorid_res, T3D_CLR_N, NULL, 0);
} /* t3d_colorid_init */
