#if DEBUG
#if 0

   Debug routines

#endif

#include <phigs/phigs.h>
#include "stdefun.h"
#include "debug.h"

#undef ppolyline3

static char *unknown = "UnKnown??";
#define NMA(a,i) (0<=i && i < (sizeof(a)/sizeof(a[0])) ? a[i] : unknown)


void t3d_Dppolyline3  _P1((Ppoint_list3 *, ppl))
{
   int      i;
   Ppoint3  *pp = ppl->points;

   fprintf(stderr, "\nCalling ppolyline3() with num_points=%d:\n",
                   ppl->num_points);
   for (i = 0;  i < ppl->num_points;  i++) {
      fprintf(stderr, "points[%d]= [%g, %g, %g]\n", 
                      i, pp[i].x, pp[i].y, pp[i].z);
   }

   ppolyline3(ppl);
} /* t3d_Dppolyline3 */


void t3d_ws_status _P1((char *, msg))
{
  static char 
     *defn[] = {
        "PDEFER_ASAP",
        "PDEFER_BNIG",
        "PDEFER_BNIL",
        "PDEFER_ASTI",
        "PDEFER_WAIT"
     },
     *modn[] = {
        "PMODE_NIVE",
        "PMODE_UWOR",
        "PMODE_UQUM"
     },
     *srfn[] = {
        "PSURF_NOT_EMPTY",
        "PSURF_EMPTY"
     },
     *vistn[] = {
        "PVISUAL_ST_CORRECT",
        "PVISUAL_ST_DEFER",
        "PVISUAL_ST_SIMULATED"
     };

   Pint              error_ind = -1;
   Pdefer_mode       def_mode = -1;
   Pmod_mode         mod_mode = -1;
   Pdisp_surf_empty  disp_empty = -1;
   Pvisual_st        state = -1;

   fprintf(stderr, "%s - WS status:\n", msg);
   pinq_disp_upd_st(1, &error_ind, &def_mode, &mod_mode, &disp_empty, &state);


   fprintf(stderr, "\terror_ind=%d, def_mode=%s, mod_mode=%s\n",
                   error_ind, NMA(defn, def_mode), NMA(modn, mod_mode)); 
   fprintf(stderr, "\tdisp_empty=%s, state=%s\n", 
                   NMA(srfn, disp_empty), NMA(vistn, mod_mode));
} /* t3d_ws_status */


void st_pr_mat3 _P2((char *, msg), (Pmatrix3, mat))
{
   int  i, j;

   fprintf(stderr, "\t%s", msg);
   for (i = 0;  i < 4;  i++) {
   fprintf(stderr, "\n\t\t", msg);
      for (j = 0;  j < 4;  j++) {
         fprintf(stderr, "%8g  ", mat[i][j]);
      }
   }
   fprintf(stderr, "\n");
} /* st_pr_mat3 */


static void t3d_show_vrep _P2((char *, msg), (Pview_rep3 *, vrep))
{
   static char
     *clpn[] = {
        "PIND_NO_CLIP",
        "PIND_CLIP"
     };

   fprintf(stderr, "\n\t%s\n", msg);
   st_pr_mat3("ori_matrix", vrep->ori_matrix);
   st_pr_mat3("map_matrix", vrep->map_matrix);
   {
      Plimit3  *pl = &vrep->clip_limit;
      fprintf(stderr, "\tclip_limit=[%g %g] [%g %g] [%g %g]\n",
              pl->x_min, pl->x_max, pl->y_min, pl->y_max, pl->z_min, pl->z_max);
   }
                   
   fprintf(stderr, "\txy_clip=%s, tback_clip=%s, tfront_clip=%s\n",
                   NMA(clpn, vrep->xy_clip),
                   NMA(clpn, vrep->back_clip),
                   NMA(clpn, vrep->front_clip) );
} /* t3d_show_vrep */

void t3d_view_status _P1((char *, msg))
{
   static char
     *updn[] = {
        "PUPD_NOT_PEND",
        "PUPD_PEND"
     };

   Pint              error_ind = -1;
   Pupd_st           update_state = -1;
   Pview_rep3        cur_rep, req_rep;

   fprintf(stderr, "%s - View status:\n", msg);
   pinq_view_rep(1, 1, &error_ind, &update_state, &cur_rep, &req_rep);


   fprintf(stderr, "\terror_ind=%d, update_state=%s\n", 
                   error_ind, NMA(updn, update_state));
   
   t3d_show_vrep("CUR_rep", &cur_rep);
   t3d_show_vrep("REQ_rep", &req_rep);
} /* t3d_view_status */
#endif /* DEBUG */
