#if 0

   space grid structure

#endif

#include "phigs/phigs.h"
#include "colorid.h"
#include "grid.h"
#include "baseid.h"
#include "debug.h"

#undef ppolyline3

int  t3d_space_grid  _P4(
     (int, nxy), /* # of XY mesh */
     (int, nz),  /* # of Z mesh */
     (double, xysize), /* XY size */
     (double, zsize)   /* Z size */ )
{
   int           i, j;
   Ppoint3       p[5];
   Ppoint_list3  pl;
   Pfloat        xy, z, d;

   DHERE0;
   popen_struct( T3D_ID_GRID );
   pset_linewidth( 1.0);
   pset_line_colr_ind( t3d_colorid(T3D_CLR_WHITE) );

   pl.points = p;

   /* XY  squares */    
   /*             */
   /*   3-----2   */
   /*   |     |   */
   /*   |  Z  |   */
   /*   |     |   */
   /*  4/0----1   */
   /*             */
   pl.num_points = 5;
   p[0].x = p[3].x = p[4].x = 0.;
   p[1].x = p[2].x = xysize;
   p[0].y = p[1].y = p[4].y = 0.;
   p[2].y = p[3].y = xysize;

   d = zsize / (Pfloat)nz;

   for (i = 1;  i <= nz;  i++) {
      z = ((Pfloat)i) * d;
      for (j = 0;  j < 5;  j++) {
         p[j].z = z;
      }
      if (i == nz) {
         pset_linewidth(3.0);
      }
      ppolyline3(&pl);
   }
   pset_linewidth( 1.0);

   /* Z segments + bottom XY*/
   pl.num_points = 4;
   p[0].z = p[3].z = zsize;
   p[1].z = p[2].z = 0.;

   d = xysize / (Pfloat)nxy;

   /*  .....  */
   /*  | Z |   */
   /*  .....  */
      /* p[0].y = p[1].y = (j ? xysize : 0.); */
      p[0].y = p[1].y = 0.;
      p[2].y = p[3].y = xysize;
      for (i = 0;  i <= nxy;  i++) {
         for (j = 0, xy = ((Pfloat)i) * d;  j < 4;  j++) {
            p[j].x = xy;
         }
         ppolyline3(&pl);
      }
      
   /*  .---.  */
   /*  . Z .  */
   /*  .---.  */
      p[0].x = p[1].x = 0.;
      p[2].x = p[3].x = xysize;
      for (i = 1;  i < nxy;  i++) {
         for (j = 0, xy = ((Pfloat)i) * d;  j < 4;  j++) {
            p[j].y = xy;
         }
         ppolyline3(&pl);
      }
      

   /* 2 more segments */
   pl.num_points = 2;
   p[0].z = p[1].z = 0.;
   p[0].x = 0.;  p[1].x = xysize;

   p[0].y = p[1].y = 0.;
   ppolyline3(&pl);

   p[0].y = p[1].y = xysize;
   ppolyline3(&pl);

#if DEBUG0
   /* 2 more origin-identifier segments */
   p[0].x = p[0].y = 0.;
   p[1].y = 0;  p[1].x = -2 * xysize / (double)nxy;
   ppolyline3(&pl);
   p[1].x = 0;  p[1].y = -xysize / (double)nxy;
   ppolyline3(&pl);
#endif

   pclose_struct();

   DHERE0;
   return( T3D_ID_GRID );

} /* t3d_space_grid */

