#include "stdefun.h"
#include "baseid.h"
#include "config.h"
#include "pieces.h"
#include "debug.h"


static T3D_CONFIG_ORIENT  piece_conf[ T3D_PIECE_N ];


T3D_CONFIG_ORIENT *
t3d_piece_config  _P1((int, id))
{
   DASSERT(T3D_PIECE_FIRST <= id && id <= T3D_PIECE_LAST);
   return( &piece_conf[ id - T3D_PIECE_FIRST ]);
} /* t3d_piece_config */


void t3d_genpieces()
{
   typedef struct {
      int        id;
      T3D_4CUBES  fourc;
   } ID4C;

#if 0
#define _L
#define _R

   static ID4C  whow[] = {
      {T3D_PIECE_LONG,  {{{0, 1, 1}, {1, 1, 1}, {2, 1, 1}, { 3, 1, 1}}}},
      {T3D_PIECE_LONG,  {0, 1, 1}, {1, 1, 1}, {2, 1, 1}, { 3, 1, 1}}
   }
#endif
   static ID4C  pieces[] = {
      {T3D_PIECE_LONG,  _L _L{0, 1, 1}, {1, 1, 1}, {2, 1, 1}, { 3, 1, 1}_R _R},
      {T3D_PIECE_BLOCK, _L _L{1, 1, 1}, {2, 1, 1}, {1, 1, 2}, { 2, 1, 2}_R _R },
      {T3D_PIECE_TEE,   _L _L{0, 1, 2}, {1, 1, 2}, {2, 1, 2}, { 1, 1, 1}_R _R },
      {T3D_PIECE_ELL,   _L _L{0, 1, 2}, {1, 1, 2}, {2, 1, 2}, { 2, 1, 1}_R _R },
      {T3D_PIECE_ZEE,   _L _L{0, 1, 2}, {1, 1, 2}, {1, 1, 1}, { 2, 1, 1}_R _R },
      {T3D_PIECE_PEAK,  _L _L{2, 1, 1}, {1, 1, 1}, {1, 2, 1}, { 1, 1, 2}_R _R },
      {T3D_PIECE_ESS1,  _L _L{2, 1, 1}, {1, 1, 1}, {1, 2, 1}, { 2, 1, 2}_R _R },
      {T3D_PIECE_ESS2,  _L _L{2, 1, 1}, {1, 1, 1}, {1, 2, 1}, { 1, 2, 2}_R _R }
   };

   int  i;

   DASSERT(T3D_PIECE_N * sizeof(pieces[0]) == sizeof(pieces));

   for (i = 0;  i < sizeof(pieces) / sizeof(pieces[0]);  i++) {
      t3d_make_piece_config( &piece_conf[i], &pieces[i].fourc); 
   }
 
} /* t3d_genpieces */

   
