#if 0

   The play scene

#endif

/* #undef DEBUG */

#include <stdio.h>
#include <phigs/phigs.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>

/*
 * Include files required for all Toolkit programs
 */
#include <X11/Intrinsic.h>     /* Intrinsics Definitions*/
#include <X11/StringDefs.h>    /* Standard Name-String definitions*/

/*
 * Public include file for widgets we actually use in this file.
 */
#include <X11/Xaw/Label.h>     /* Athena Label Widget */


#include "stdefun.h"
#include "assign.h"
#include "space.h"
#include "baseid.h"
#include "grid.h"
#include "gridcap.h"
#include "debug.h"


static int hsr_on = 0;
static int opened = 0;
static int posted = 0;


static void 
set_hsr  _P1(
   (char *, progname)
)
{
   Pint       error_ind, ws_type, length_list, inta[7];
   Pconnid    conn_id;
   Pint_list  il;
   int        i;

   pinq_ws_conn_type(1, NULL, &error_ind, &conn_id, &ws_type);
   if (error_ind != 0) {
      DHERE; 
      (void)fprintf( stderr, "error_ind=%d\n", error_ind);
      return;
   }

   il.num_ints = -1;    /* Grabage */
   il.ints = inta + 1;  /* save [0] for search-boundary */

   pinq_hlhsr_mode_facs(ws_type, 6, 0, &error_ind, &il, &length_list);
   if (error_ind != 0) {
      DHERE; 
      (void)fprintf( stderr, "error_ind=%d\n", error_ind);
      return;
   }

   inta[0] = PHIGS_HLHSR_MODE_ZBUFF; /* Before array! Catch next for-loop */
   for (i = il.num_ints;  inta[i] != PHIGS_HLHSR_MODE_ZBUFF;  i--); 
   if (i == 0) {
      DHERE0;
      (void)fprintf(stderr, "%s: Z-buffer/HSR not supported!\n", progname);
   } else {
      pset_hlhsr_mode(1, PHIGS_HLHSR_MODE_ZBUFF);
      hsr_on = 1;
   }
} /* set_hsr */


int
t3d_hsr_on()
{
   return( hsr_on);
} /* t3d_hsr_on */


void
t3d_space_init  _P3(
   (Widget, toplevel),
   (Widget, space),
   (char *, caller)
)
{
   static Pmatrix3      r = { {1., 0., 0., 0.},
                              {0., 1., 0., 0.},
                              {0., 0., 1., 0.},
                              {0., 0., 0., 1.} };
   Pconnid_x_drawable	connid;
   Display		*display;
   Window               xid;
   Colormap             default_cmap;
   Ppoint		text_pt;
   Pxphigs_info		xphigs_info;
   unsigned long	mask;
   Pint                 new_ws;
   int                  i;
   
   display = XtDisplay(space);
   xid = XtWindow(space);
   /* Tell the window manager to keep track of the colormap. */
   XSetWMColormapWindows( XtDisplay(toplevel), XtWindow(toplevel), &xid, 1 );

   /* Open PHIGS, telling it not to monitor window events. */
   mask = PXPHIGS_INFO_FLAGS_NO_MON  /* | PXPHIGS_INFO_ARGS */;
   xphigs_info.flags.no_monitor = 1;
   popen_xphigs( PDEF_ERR_FILE, PDEF_MEM_SIZE, mask, &xphigs_info );

   connid.display = display;
   connid.drawable_id = xid;

   new_ws = phigs_ws_type_create(phigs_ws_type_x_drawable,
                                 /* PHIGS_X_BUF_MODE, PHIGS_BUF_SINGLE, */
                                 PHIGS_X_BUF_MODE, PHIGS_BUF_DOUBLE,
                                 NULL);
   {(void)phigs_ws_type_set( 
#if NeedVarargsPrototypes
                     (_PxphigsWst)      /* casting because of bad phigs.h ! */
#endif /*                         \                                         */
                                   new_ws, 
                     PHIGS_X_BUF_MODE, PHIGS_BUF_DOUBLE,
                     NULL);
   }
   popen_ws( 1, &connid, new_ws );
   {
      Pws_st  ws_state;
      pinq_ws_st(&ws_state);
      if (ws_state != PWS_ST_WSOP) {
         fprintf(stderr, "%s: ERROR - Phigs Workstation not opened\n", caller);
         exit(1);
      }
   }
   
   pset_disp_upd_st( 1, PDEFER_WAIT, PMODE_NIVE);

   set_hsr(caller);

   (void)t3d_space_grid(4, 15, 4., 15.);
   t3d_grid_cap();

   popen_struct( T3D_ID_ROOT );
      pexec_struct( T3D_ID_SUB );
   pclose_struct();

   popen_struct( T3D_ID_SUB );
      pset_view_ind(1);
      pset_local_tran3(r, PTYPE_PRECONCAT);
      pexec_struct( T3D_ID_GRID );
   pclose_struct();

   opened = 1;
} /* t3d_space_init */


void
t3d_space_post()
{
   posted = 1;
   ppost_struct( 1, T3D_ID_ROOT, 0.0 );
} /* t3d_space_post */


void
t3d_space_redraw()
{
   if (posted) {
      predraw_all_structs( 1, PFLAG_ALWAYS );
   }
} /* t3d_space_redraw */


void
t3d_end_space()
{
   if (opened) {
      opened = 0;
      pclose_ws( 1);
      pclose_phigs();
   }
} /* t3d_end_space */
