#if 0

  View menu

#endif

#include "stdefun.h"
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xmu/Converters.h>


#include "view.h"
#include "xview.h"
#include "debug.h"

typedef enum {  /* Note: There is a string array to be matched with !! */

   /********/
   /* vmap */

   VP_VMAP_WIN_XMIN,
   VP_VMAP_WIN_XMAX,
   VP_VMAP_WIN_YMIN,
   VP_VMAP_WIN_YMAX,

   /* Pproj_type the one and only who is not a Pfloat !! */

   VP_VMAP_PRJ_REFP_X,
   VP_VMAP_PRJ_REFP_Y,
   VP_VMAP_PRJ_REFP_Z,

   VP_VMAP_DIST,
   VP_VMAP_BACK,
   VP_VMAP_FRONT,


   /*******/
   /* vrp */

   VP_VRP_X,
   VP_VRP_Y,
   VP_VRP_Z,

   /*******/
   /* vpn */

   VP_VPN_DX,
   VP_VPN_DY,
   VP_VPN_DZ,

   /*******/
   /* vup */

   VP_VUP_DX,
   VP_VUP_DY,
   VP_VUP_DZ,

   /************************/
   /* viewport (vmap also) */

   VP_VMAP_PRT_WIN_XMIN,
   VP_VMAP_PRT_WIN_XMAX,
   VP_VMAP_PRT_WIN_YMIN,
   VP_VMAP_PRT_WIN_YMAX,
   VP_VMAP_PRT_WIN_ZMIN,
   VP_VMAP_PRT_WIN_ZMAX,

   N_ENUM_VIEW_PAR

} ENUM_VIEW_PAR;


typedef enum {
   LOW,
   HIGH,
   N_LOWHIGH
} LOWHIGH;


typedef enum {
   LCH_LOW,
   LCH_CURR,
   LCH_HIGH,
   LCH_SIZE
} LCH_ENUM;

typedef struct {
   float  v[LCH_SIZE];
} LCH;

typedef struct {
   Widget             popper;  /* commander to get re-sensitive */
   Widget             shell;   /* lower poped up shell */
   Widget             dialog; 
   struct _ValueCtrl  *upper_vc;
   float              value;
   LOWHIGH            lh_index;
} POPUP;


typedef struct _ValueCtrl {
   Widget         /* father, */
                  scroll,
                  status;
   POPUP          extreme[N_LOWHIGH];
   char           *name;
   ENUM_VIEW_PAR  self_index;
   Pfloat         *fadd;
} ValueCtrl;



/******************************************/
/*   G l o b a l     V a r i a b l e s    */

   
static T3D_VIEW_PARAMS  vparams;
static char            *proj_type_name[] = {
                          "Parallel",      /* PTYPE_PARAL */
                          "Perspective"    /* PTYPE_PERSPECT */
                       };
static Widget          validity;

/*                                        */
/******************************************/


static void
init_defaults _P3(
   (T3D_VIEW_PARAMS *, vparams),
   (LCH *,            lch),
   (Widget,           top)
)
{
   static XtResource
             vpres[] = {
                {
                   "perspective",
                   "Perspective",
                   XtRInt,
                   sizeof(Pproj_type),
                   XtOffsetOf(T3D_VIEW_PARAMS, vmap.proj_type),
                   XtRImmediate,
                   (XtPointer)1,
                }
             };
   static char *mvm[] = {"min", "val", "max"},
               *lchname[] = { /* Must be in the same order of lch!! */
                  "WinXMin", "WinXMax", "WinYMin", "WinYMax",
                  "ProjRefX", "ProjRefY", "ProjRefZ", 
                  "Dist", "Back", "Front",
                  "VrpX", "VrpY", "VrpZ", 
                  "VpnX", "VpnY", "VpnZ", 
                  "VupX", "VupY", "VupZ", 
                  "ViewportXMin", "ViewportXMax", 
                  "ViewportYMin", "ViewportYMax",
                  "ViewportZMin", "ViewportZMax"
               };

   int         i, lchi, m;
   XtResource  lchres[ 3 * XtNumber(lchname) ];
   char        name[   3 * XtNumber(lchname) ][20], 
               class[  3 * XtNumber(lchname) ][20]; 
   float       *pf;

   DHERE0; DPR0((stderr, "XtNumber(lchname)=%d\n", XtNumber(lchname)));
   XtGetApplicationResources( top, vparams, vpres, XtNumber(vpres), NULL, 0);
   DPR0((stderr, "proj=%d\n", vparams->vmap.proj_type));
 
   for (lchi = i = 0;  lchi < XtNumber(lchname);  lchi++) {
      for (m = 0;  m < XtNumber(mvm);  m++, i++) {
         char *nm = name[i],  *cl = class[i];
         lchres[i].resource_name = nm;
         lchres[i].resource_class = cl;
         lchres[i].resource_type = XtRFloat;
         DASSERT(sizeof(lch[i]) == 3 * sizeof(float));
         lchres[i].resource_size = sizeof(float);
         lchres[i].default_type = XtRFloat;
         (void)strcpy( nm, mvm[m]);
         DASSERT(strlen( mvm[m]) == 3);
         (void)strcpy( nm + 3, lchname[lchi]);
         strcpy( cl, nm);
         cl[0] = toupper( cl[0]);
         pf = &(lch[lchi].v[m]);

         /* Target and default address, are actually the same */
         lchres[i].resource_offset = ((char *)pf) - ((char *)lch);
         lchres[i].default_addr = (XtPointer)pf;
      }
   }
   XtGetApplicationResources( top, lch, lchres, XtNumber(lchres), NULL, 0);

#if DEBUG0
   for (lchi = i = 0;  lchi < XtNumber(lchname);  lchi++) {
      for (m = 0;  m < XtNumber(mvm);  m++, i++) {
         fprintf( stderr, "[%s / %s] lch[%d].v[%d] = %g\n", 
                          class[i], name[i], lchi, m, lch[lchi].v[m]);
      }
   }                     
#endif /* DEBUG */
   DHERE0;
} /* init_defaults */


static  int
try_update_view()
{
   int  rc = t3d_set_view(&vparams);
   XtVaSetValues( validity, XtNlabel, (rc ? "Valid" : "INVALID"), NULL);
   if (rc) {
      t3d_cube_orient( vparams.vpn.delta_x, 
                      vparams.vpn.delta_y, 
                      vparams.vpn.delta_z); 
   }
   return(rc);
} /* try_update_view */
   

static void
popup_viewbox  _P3(
   (Widget,    widget),
   (XtPointer, closure),
   (XtPointer, callData) )
{
   DHERE0;
} /* popup_viewbox */


static void
ViewboxDone  _P3(
   (Widget,    widget),
   (XtPointer, closure),
   (XtPointer, callData) )
{
   POPUP     *ppopup_view = (POPUP *)closure;
   DHERE0;
   XtPopdown( ppopup_view->shell);
   XtSetSensitive( ppopup_view->popper, TRUE);
} /* ViewboxDone */


static void
Thumbed  _P3(
   (Widget,    widget),
   (XtPointer, closure),
   (XtPointer, top_ptr) )
{
   ValueCtrl  *pvc = (ValueCtrl *)closure;
   float      s = *(float *)top_ptr, 
              low = pvc->extreme[LOW].value,
              high = pvc->extreme[HIGH].value,
              value = low + s * (high - low);
   Widget     label = pvc->status;
   char       message[80]; /* must be enough!! */

   sprintf( message, "%s = %g", pvc->name, value);
   XtVaSetValues( label, XtNlabel, message, NULL );
   *pvc->fadd = value;
   (void)try_update_view();
} /* Thumbed */


/* Ensure: low <= curr <= high */
static double
slch  _P3(
   (float *, plow),
   (float *, phigh),
   (float *, pcurr) )
{
   float  s, d,
          low = *plow, 
          high = *phigh,
          curr = *pcurr;

   if (low > high) {
      low = high;
   }
   if (curr < low) {
      curr = low;
   } else if (high < curr) {
      curr = high;
   }

   d = high - low;
   s = (d != 0 ?  (curr - low) / d  : 0.);
   /* recalcualte, just to be consistent */
   curr = low + s * (high - low);

   *plow = low, 
   *phigh = high,
   *pcurr = curr;

   return(s);
} /* slch */


static void 
popup_set_limit  _P3(
   (Widget,    widget),
   (XtPointer, closure),
   (XtPointer, callData) )
{
    Position  x, y;
    Dimension width, height, popw, poph, w, h;
    POPUP     *ppopup = (POPUP *)closure;
    Widget    popper = ppopup->popper;

    XtVaGetValues( popper, XtNwidth, &width, XtNheight, &height, NULL);
    
    w = width / 2;
    h = height / 2;
    XtTranslateCoords( popper, (Position) w, (Position) h, &x, &y);      

    /* move popup shell to this position (it's not visible yet) */
    XtVaSetValues( ppopup->shell,  XtNx, x, XtNy, y,  NULL);
#if 0 /* doesn't work well */
    XtVaGetValues( ppopup->shell, XtNwidth, &popw, XtNheight, &poph, NULL);

#   undef MIN
#   define MIN(x,y)  (int)((int)(x) < (int)(y) ? x : y)

    w = w + MIN(width - 1, popw)/ 2;
    h = h + MIN(height - 1, poph)/ 2;
    XWarpPointer( XtDisplay(popper), 
                  XtWindow(popper) /* src_w */, 
                  None /* dest_w */,
                  0, 0, width, height, /* src_ <x, y, width, height> */
                  w, h /* dest_ <x, y> -  to be inside */);
#endif /* 0 */
} /* popup_set_limit */

 
static void
set_limit  _P3(
   (Widget,    widget),
   (XtPointer, closure),
   (XtPointer, callData) )
{
    String  string;
    int     rc;
    float   f = -13., curr, l, h, s;
    POPUP   *ppopup = (POPUP *)closure;

    DHERE0;
    XtPopdown( ppopup->shell );
    string = XawDialogGetValueString( ppopup->dialog );
    rc = sscanf(string, "%f", &f);
    DPR0((stderr, "rc=%d, f=%g\n", rc, f));
    if (rc == 1) {
       curr = *ppopup->upper_vc->fadd;
       if ( ppopup->lh_index == LOW && f <= curr ||
            ppopup->lh_index == HIGH && curr <= f ) {
          ppopup->value = f;
          XtVaSetValues( ppopup->popper, XtNlabel, string, NULL);
          l = ppopup->upper_vc->extreme[LOW].value;
          h = ppopup->upper_vc->extreme[HIGH].value;
          s = slch(&l, &h, &curr); 
          XawScrollbarSetThumb( ppopup->upper_vc->scroll, s, 1./30.);
       }
    }
    XtSetSensitive( ppopup->popper, TRUE);
} /* set_limit */


static void
flip_proj  _P3(
   (Widget,    widget),
   (XtPointer, client),
   (XtPointer, callData) )
{
   
   Pproj_type  new  = (vparams.vmap.proj_type == PTYPE_PARAL 
                         ? PTYPE_PERSPECT
                         : PTYPE_PARAL);
   vparams.vmap.proj_type = new;
   XtVaSetValues(widget, XtNlabel, proj_type_name[new], NULL);
   (void)try_update_view();
} /* flip_proj */


static void
float_dialog  _P3(
   (POPUP *, ppopup_ctrl),
   (Widget,  father),
   (Widget,  top_level) )
{
   Widget   dialogDone;
   char     flt_str[80];

   sprintf(flt_str, "%g", ppopup_ctrl->value);
   ppopup_ctrl->popper =
            XtVaCreateManagedWidget( NULL, commandWidgetClass, father,
                                     XtNlabel, flt_str, NULL);
   ppopup_ctrl->shell =
            XtCreatePopupShell( NULL, transientShellWidgetClass,
                                 top_level, NULL, ZERO);
   ppopup_ctrl->dialog =
            XtVaCreateManagedWidget( "dialog", dialogWidgetClass,
                                     ppopup_ctrl->shell,
                                     XtNlabel, "Please modify:", 
                                     XtNvalue, flt_str,
                                     NULL);
   dialogDone = XtCreateManagedWidget( "Done", commandWidgetClass,
                                       ppopup_ctrl->dialog,
                                       NULL, ZERO);

   XtAddCallback( dialogDone, XtNcallback, set_limit, ppopup_ctrl);
   XtAddCallback( ppopup_ctrl->popper, XtNcallback, popup_set_limit,
                  ppopup_ctrl);
   XtAddCallback( ppopup_ctrl->popper, XtNcallback, XtCallbackExclusive,
                  ppopup_ctrl->shell);
} /* float_dialog */


static void
create_vc  _P5(
   (ValueCtrl *, pvc),
   (Widget,      parent),
   (char *,      name),
   (LCH *,       plch),
   (int,         do_limits)
)
{
   Widget   box0, box_limit, box, label;
   float    low = plch->v[LCH_LOW],
            high = plch->v[LCH_HIGH],
            curr = plch->v[LCH_CURR],
            s;
   LOWHIGH  lhi;
   char     message[80]; /* must be enough!! */

   s = slch(&low, &high, &curr);
   pvc->name = name;
   *(pvc->fadd) = curr;

   for (lhi = LOW;  lhi < N_LOWHIGH;  lhi++) {
      pvc->extreme[lhi].upper_vc = pvc;
      pvc->extreme[lhi].lh_index = lhi;
   }
   pvc->extreme[LOW].value = low;
   pvc->extreme[HIGH].value = high;

   sprintf( message, "%s = %g", name, curr);

   if (do_limits) {
      box0 = XtVaCreateManagedWidget( NULL, boxWidgetClass, parent, 
                                      XtNorientation, XtorientHorizontal, NULL);

      box_limit = XtCreateManagedWidget( NULL, boxWidgetClass, box0, 
                                         NULL, ZERO);
      float_dialog(&pvc->extreme[HIGH], box_limit, parent);
      float_dialog(&pvc->extreme[LOW], box_limit, parent);
      box = XtCreateManagedWidget( NULL, boxWidgetClass, box0, NULL, ZERO);
   } else {
      box = XtCreateManagedWidget( NULL, boxWidgetClass, parent, NULL, ZERO);
   }
   label = XtVaCreateManagedWidget( name, labelWidgetClass, box,
                                    XtNlabel, message,
                                    NULL);
   pvc->status = label;
   pvc->scroll = XtVaCreateManagedWidget( "scrollbar", scrollbarWidgetClass, 
                                          box,
                                          XtNorientation, XtorientHorizontal,
                                          NULL);
   XawScrollbarSetThumb(pvc->scroll, s, 1./30.);

   XtAddCallback(pvc->scroll, XtNjumpProc, Thumbed, pvc);
} /* create_vc */


static float  *
vpar_fadd _P2(
   (T3D_VIEW_PARAMS_P,  pvr),
   (ENUM_VIEW_PAR, vi) )
{
   static int
      fadd[] = {

         XtOffset(T3D_VIEW_PARAMS_P, vmap.win.x_min),
         XtOffset(T3D_VIEW_PARAMS_P, vmap.win.x_max),
         XtOffset(T3D_VIEW_PARAMS_P, vmap.win.y_min),
         XtOffset(T3D_VIEW_PARAMS_P, vmap.win.y_max),

         XtOffset(T3D_VIEW_PARAMS_P, vmap.proj_ref_point.x),
         XtOffset(T3D_VIEW_PARAMS_P, vmap.proj_ref_point.y),
         XtOffset(T3D_VIEW_PARAMS_P, vmap.proj_ref_point.z),

         XtOffset(T3D_VIEW_PARAMS_P, vmap.view_plane),
         XtOffset(T3D_VIEW_PARAMS_P, vmap.back_plane),
         XtOffset(T3D_VIEW_PARAMS_P, vmap.front_plane),


         XtOffset(T3D_VIEW_PARAMS_P, vrp.x),
         XtOffset(T3D_VIEW_PARAMS_P, vrp.y),
         XtOffset(T3D_VIEW_PARAMS_P, vrp.z),

         XtOffset(T3D_VIEW_PARAMS_P, vpn.delta_x),
         XtOffset(T3D_VIEW_PARAMS_P, vpn.delta_y),
         XtOffset(T3D_VIEW_PARAMS_P, vpn.delta_z),

         XtOffset(T3D_VIEW_PARAMS_P, vup.delta_x),
         XtOffset(T3D_VIEW_PARAMS_P, vup.delta_y),
         XtOffset(T3D_VIEW_PARAMS_P, vup.delta_z),

         XtOffset(T3D_VIEW_PARAMS_P, vmap.proj_vp.x_min),
         XtOffset(T3D_VIEW_PARAMS_P, vmap.proj_vp.x_max),
         XtOffset(T3D_VIEW_PARAMS_P, vmap.proj_vp.y_min),
         XtOffset(T3D_VIEW_PARAMS_P, vmap.proj_vp.y_max),
         XtOffset(T3D_VIEW_PARAMS_P, vmap.proj_vp.z_min),
         XtOffset(T3D_VIEW_PARAMS_P, vmap.proj_vp.z_max)

      };

   char  *xpvr = (char *)pvr;
   int   offset = fadd[vi];

   DASSERT(XtNumber(fadd) == N_ENUM_VIEW_PAR);
   return( (float *)(xpvr + offset) );
} /* vpar_fadd */


void
t3d_xview_init  _P2(
   (Widget, toplevel),
   (Widget, command))
{
   static POPUP      popup_view = {NULL, NULL, /* unused */NULL};

   /* The following string array must be indexed exactly as ENUM_VIEW_PAR */
   static char *view_par_name[] = {

      /********/
      /* vmap */

      "Xmin",
      "Xmax",
      "Ymin",
      "Ymax",

      "X",
      "Y",
      "Z",

      "View",
      "Back",
      "Front",

      /*******/
      /* vrp */

      "X",
      "Y",
      "Z",

      /*******/
      /* vpn */

      "DX",
      "DY",
      "DZ",

      /*******/
      /* vup */

      "X",
      "Y",
      "Z",

      /************/
      /* viewport */
      "Xmin",
      "Xmax",
      "Ymin",
      "Ymax",
      "Zmin",
      "Zmax"

   };

   static LCH default_values[] = {
      { -3., -2.1, 0.}  /* VMAP_WIN_XMIN*/,
      {  0.,  2.1, 3.}  /* VMAP_WIN_XMAX*/,
      { -3., -2.1, 0.}  /* VMAP_WIN_YMIN*/,
      {  0.,  2.1, 3.}  /* VMAP_WIN_YMAX*/,

      {   -2.,   0.,   6.}  /* VMAP_PRJ_REFP_X*/,
      {   -2.,   0.,   6.}  /* VMAP_PRJ_REFP_Y*/,
      {  -20.,  15.,  20.}  /* VMAP_PRJ_REFP_Z*/,

      {  -5.,  -5.,  5.}    /* VMAP_DIST*/,
      { -20., -20., 20.}    /* VMAP_BACK*/,
      { -20.,   0., 20.}    /* VMAP_FRONT*/,

      { -1.,  2.,  5.}  /* VRP_X */,
      { -1.,  2.,  5.}  /* VRP_Y */,
      {  0., 20., 40.}  /* VRP_Z */,

      { -1.,  0., 1.}  /* VPN_DX*/,
      { -1.,  0., 1.}  /* VPN_DY*/,
      { -1.,  1., 1.}  /* VPN_DZ*/,

      { -1., 0., 1.}  /* VUP_DX*/,
      { -1., 1., 1.}  /* VUP_DY*/,
      { -1., 0., 1.}  /* VUP_DZ*/,

      /* exceptional */
      { 0., 0., 1.}  /* VMAP_PRT_WIN_XMIN*/,
      { 0., 1., 1.}  /* VMAP_PRT_WIN_XMAX*/,
      { 0., 0., 1.}  /* VMAP_PRT_WIN_YMIN*/,
      { 0., 1., 1.}  /* VMAP_PRT_WIN_YMAX*/,
      { 0., 0., 1.}  /* VMAP_PRT_WIN_ZMIN*/,
      { 0., 1., 1.}  /* VMAP_PRT_WIN_ZMAX*/

   };

   static ValueCtrl  vc[N_ENUM_VIEW_PAR];
   static int        proj_group[] = {
 
                        VP_VMAP_WIN_YMAX, 
                        VP_VMAP_PRJ_REFP_Z,
                        VP_VMAP_FRONT
                     },

                     orient_group[] = {
                        VP_VRP_Z,
                        VP_VPN_DZ,
                        VP_VUP_DZ
                     },

                     viewport_group[] = {
                        VP_VMAP_PRT_WIN_ZMAX
                     },

                     num_po_group[] = {
                        XtNumber(proj_group), 
                        XtNumber(orient_group),
                        XtNumber(viewport_group)
                     },
                     *super_group[] = {
                        proj_group, 
                        orient_group, 
                        viewport_group
                     };
   static char       *proj_name[] = {
                        "Window", 
                        "Reference Point",
                        "Distances", 
                     },
                     *orient_name[] = {
                        "Origin", "Plane Normal", "Up Vector"
                     },
                     **group_name[] = {proj_name, orient_name},
                     *po_name[] = {"Projection", "Orientation", "Viewport"};

   Widget            viewbox, head_box, viewboxDone, projType, 
                     /* wim1[XtNumber(widget_group) + 1], *wi = wim1 + 1,  */
                     po_wi, wi,
                     label;
   int               i, j, k, rc;


   DPR0((stderr, "XtNumber(default_values)=%d\n", XtNumber(default_values)));
   if  (XtNumber(view_par_name) != N_ENUM_VIEW_PAR ||
        XtNumber(default_values) != N_ENUM_VIEW_PAR) {
      fprintf(stderr, "array initializataion error name=%d, defval=%d, != %d\n",
                      XtNumber(view_par_name), XtNumber(default_values),
                      N_ENUM_VIEW_PAR);
      exit(0);
   }
   if (popup_view.popper || popup_view.shell) {
      DHERE;  fprintf(stderr, "I must not be called twice!\n");
      exit(0);
   }
   init_defaults( &vparams, default_values, toplevel);
   popup_view.popper = command;
   popup_view.shell = XtCreatePopupShell( "pshell", transientShellWidgetClass,
                                            toplevel, NULL, 0);
   viewbox = XtVaCreateManagedWidget( "viewbox", boxWidgetClass,
                                       popup_view.shell, 
                                       XtNorientation, XtorientVertical,
                                       NULL);
   head_box = XtVaCreateManagedWidget( NULL, boxWidgetClass, viewbox,
                                       XtNorientation, XtorientHorizontal, 
                                       NULL);
   viewboxDone = XtVaCreateManagedWidget( "viewboxDone", commandWidgetClass,
                                          head_box, 
                                          XtNlabel, "Quit Viewbox",
                                          NULL);
   projType = XtVaCreateManagedWidget( "projType", commandWidgetClass, head_box,
                                       XtNlabel, 
                                       proj_type_name[vparams.vmap.proj_type], 
                                       NULL);
   validity = XtCreateManagedWidget( "validity", labelWidgetClass, head_box,
                                     NULL, 0);

   /* View-port is exceptional-horizontal */
   for (k = j = 0;  k < 3;  k++) {
      po_wi = XtVaCreateManagedWidget( NULL, boxWidgetClass, viewbox,
                              XtNorientation, XtorientHorizontal, NULL);
      (void)XtVaCreateManagedWidget( NULL, labelWidgetClass, po_wi,
                                     XtNlabel, po_name[k], 
                                     NULL);
      for (i = 0;  i < num_po_group[k];  i++) {
         wi = XtVaCreateManagedWidget( "viewctrl", boxWidgetClass, po_wi, 
                                       XtNorientation,
                                          (k != 2 ? XtorientVertical
                                                  : XtorientHorizontal),
                                       NULL);
         if (k != 2) {
            (void)XtVaCreateManagedWidget( NULL, labelWidgetClass, wi,
                                           XtNlabel, group_name[k][i], NULL);
         }
         for (;  j <= super_group[k][i];  j++) {
            vc[j].self_index = (ENUM_VIEW_PAR)j;
            vc[j].fadd = vpar_fadd(&vparams, j);
            create_vc( &vc[j], wi, view_par_name[j], &default_values[j],
                       k != 2);
         }
      }
   }
   DASSERT(j == N_ENUM_VIEW_PAR);
   /* XtManageChildren(wim1, XtNumber(widget_group) + 1); */

   XtAddCallback( popup_view.popper, XtNcallback, popup_viewbox, toplevel);
   XtAddCallback( popup_view.popper, XtNcallback, XtCallbackNone,
                  popup_view.shell);
   XtAddCallback( viewboxDone, XtNcallback, ViewboxDone, &popup_view);
   XtAddCallback( projType, XtNcallback, flip_proj, NULL);

   rc = try_update_view();
   if (!rc) {
      fprintf(stderr, "Initlal view parameters are invalid\n");
   }
} /* t3d_xview_init */
